/*___________________________________________________________________________*/
/* IBM Optimization Solutions and Library Optimization Library               */
/* ekkc.h - OSL C header file                                                */
/* (c) IBM Corp, 1990,1997 All rights reserved.                              */
/*                                                                           */
/* US Government Users Restricted Rights - Use, duplication, or disclosure   */
/* restricted by GAS ADP Schedule Contract with IBM Corp.                    */
/*___________________________________________________________________________*/

#if defined(INTEL)&&!defined(LINUX)

#ifdef __cplusplus
extern "C"{
#endif
#include <string.h>

/* Temporary variables used in FORTRAN linkage */

static long    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static long    ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;

/* OSL routines */
#ifndef OSLLIBAPI
#ifdef OSLMSDLL
#define OSLLINKAGE __stdcall
#define OSLLINKAGE_CB  __cdecl
#define OSLLIBAPI __declspec(dllimport)
#endif
#ifdef OSLMSSTAT
#define OSLLINKAGE __stdcall
#define OSLLINKAGE_CB  __cdecl
#define OSLLIBAPI
#endif
#if defined(OSLWCSTAT) || defined(OSLWCDLL)
#define OSLLINKAGE
#define OSLLINKAGE_CB  
#define OSLLIBAPI
#endif
#endif

OSLLIBAPI void OSLLINKAGE  EKKBASI(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKBASO(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKBCDO(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKBMPR(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKBMPS(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKBSLV(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKCGET(long *,double *,char *,long *);
OSLLIBAPI void OSLLINKAGE  EKKCLCB(int *);
OSLLIBAPI void OSLLINKAGE  EKKCOL(long *,double *,long *,long *,long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKCOPY(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKCRSH(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKCSET(long *,double *,char *,long *);
OSLLIBAPI void OSLLINKAGE  EKKDSCA(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKDSCB(long *,double *,long *,long *,long *,long *,double *,long *,
               long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKDSCM(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKEMDL(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKGEMV(long *,double *,long *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKGES(long *,double *,long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKGTMD(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKGTMI(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKHIS(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKIGET(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKIMDL(long *,double *,long *,long *,long *,long *,long *,long *,
               long *,long *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKINIT(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKINVT(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKISET(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKLMDL(long *,double *,long *,long *,long *,long *,double *,double *,
               double *,double *,double *,long *,long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKLPDC(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKMPRE(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKMPS(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKMSAV(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKMSET(long *,double *,long *,long *,long *,long *,
               long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKMSLV(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKMSTR(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKNAME(long *,double *,long *,char *,long*,long *,
               char *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKNFES(long *,double *,long *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKNGET(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKNLBS(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKNMDL(long *,double *,long *,long *,long *,long *, long *,long *, double *,double *,double *,double *, double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKNSLV(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKNWMT(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKPMDL(long *,double *,double *,double *,double *,double *,double *, long *);
OSLLIBAPI void OSLLINKAGE  EKKPOPS(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKPRSL(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKPRTS(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKPSHS(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKPSSL(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKPTMD(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKPTMI(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKQMDL(long *,double *,long *,long *,long *,long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKQMPS(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKQPAR(long *,double *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  EKKQSLV(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKQRMD(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKRGCB(int *, void *);
OSLLIBAPI void OSLLINKAGE  EKKRGET(long *,double *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKROW(long *,double *,long *,long *,long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKRPTB(long *,double *,long *,long *,long *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKRSET(long *,double *,double *,long *);
OSLLIBAPI void OSLLINKAGE  EKKSBND(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKSCAL(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSEL(long *,double *,char *,long *,char *,char *,
              long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKSMAP(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSOBJ(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSOS(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSPAR(long *,double *);
OSLLIBAPI void OSLLINKAGE  EKKSSLV(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  EKKSTAT(long *,double *);

#if defined(OSLWCSTAT) || defined(OSLWCDLL)
OSLLIBAPI void OSLLINKAGE  EKKFCLS(long *, char *, long *, long *);
OSLLIBAPI void OSLLINKAGE  EKKFOPN(long *, char *, char *, char *,
                      char *, char *, long *, long *, long *, long *,
                      long *, long *, long *);
#else
OSLLIBAPI void OSLLINKAGE  EKKFCLS(long *, char *, long *, long *);
OSLLIBAPI void OSLLINKAGE  EKKFOPN(long *, char *, long *, char *, long *,
                      char *, long *, char *, long *, char *, long *,
                      long *, long *);
#endif

OSLLIBAPI void OSLLINKAGE  EKKFREW(long *);
OSLLIBAPI double * OSLLINKAGE  ekkdspace95(long);

/* Redefinition for C/C++ drivers  */

#define  ekkbasi(x1,x2,i1)         (ekk_i1=i1, EKKBASI(x1,x2,&ekk_i1))

#define  ekkbaso(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKBASO(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbcdo(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKBCDO(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkbmpr(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKBMPR(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)         (ekk_i1=i1, EKKBMPS(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKBSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkclcb(i1)               (ekk_s1=i1, EKKCLCB(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    EKKCGET(x1,x2,x3,&ekk_i1))

#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKCOL(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkcopy(x1,x2,i1)         (ekk_i1=i1, EKKCOPY(x1,x2,&ekk_i1))

#define  ekkcrsh(x1,x2,i1)         (ekk_i1=i1, EKKCRSH(x1,x2,&ekk_i1))

#define  ekkcset(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    EKKCSET(x1,x2,x3,&ekk_i1))

#define  ekkdsca(x1,x2,i1,i2)      (ekk_longlong=i1,ekk_i2=i2,  \
                                    EKKDSCA(x1,x2,&ekk_longlong,&ekk_i2))

#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                    EKKDSCB(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5, \
                                    &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkdscm(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKDSCM(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKEMDL(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))


#if defined(OSLWCSTAT) || defined(OSLWCDLL)
#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekk_i2=strlen(x1), \
                                   EKKFCLS(&ekk_i1,x1,x2,&ekk_i2))
#else
#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekk_i2=strlen(x1), \
                                   EKKFCLS(&ekk_i1,x1,&ekk_i2,x2))
#endif

#if defined(OSLWCSTAT) || defined(OSLWCDLL)
#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, \
                                   ekk_i2=strlen(x1),ekk_i3=strlen(x2), \
                                   ekk_i4=strlen(x3),ekk_i5=strlen(x4), \
                                   ekk_i6=strlen(x5),ekk_i7=i2, \
                                   EKKFOPN(&ekk_i1,x1,x2, \
                                   x3,x4,x5,&ekk_i7,x6, \
                                   &ekk_i2,&ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
#else
#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, \
                                   ekk_i2=strlen(x1),ekk_i3=strlen(x2), \
                                   ekk_i4=strlen(x3),ekk_i5=strlen(x4), \
                                   ekk_i6=strlen(x5),ekk_i7=i2, \
                                   EKKFOPN(&ekk_i1,x1,&ekk_i2,x2, \
                                   &ekk_i3,x3,&ekk_i4,x4,&ekk_i5, \
                                   x5,&ekk_i6,&ekk_i7,x6))
#endif

#define  ekkfrew(i1)               (ekk_i1=i1, \
                                   EKKFREW(&ekk_i1))

#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                   (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                    EKKGEMV(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                    &ekk_z2,x4))

#define  ekkges(x1,x2,i1,x3)       (ekk_i1=i1, EKKGES(x1,x2,&ekk_i1,x3))

#define  ekkgtmd(x1,x2,i1)         (ekk_i1=i1, EKKGTMD(x1,x2,&ekk_i1))

#define  ekkgtmi(x1,x2,i1)         (ekk_i1=i1, EKKGTMI(x1,x2,&ekk_i1))

#define  ekkhis(x1,x2,i1,x3)       (ekk_i1=i1, EKKHIS(x1,x2,&ekk_i1,x3))

#define  ekkiget(x1,x2,x3,i1)      (ekk_i1=i1, EKKIGET(x1,x2,x3,&ekk_i1))

#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    EKKIMDL(x1,x2,&ekk_i1,x3,&ekk_i2,x4, \
                                    x5,&ekk_i3,x6,x7,x8,x9))

#define  ekkinit(x1,x2)            (EKKINIT(x1,x2))

#define  ekkinvt(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKINVT(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkiset(x1,x2,x3,i1)      (ekk_i1=i1, EKKISET(x1,x2,x3,&ekk_i1))

#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    EKKLMDL(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))

#define  ekklpdc(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKLPDC(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmpre(x1,x2,i1)         (ekk_i1=i1,  \
                                    EKKMPRE(x1,x2,&ekk_i1))

#define  ekkmps(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKMPS(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmsav(x1,x2,i1,x3)      (ekk_i1=i1, EKKMSAV(x1,x2,&ekk_i1,x3))

#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                    EKKMSET(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))

#define  ekkmslv(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    EKKMSLV(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmstr(x1,x2,i1,x3)      (ekk_i1=i1, EKKMSTR(x1,x2,&ekk_i1,x3))



#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   EKKNAME(x1,x2,&ekk_i1,x3, &ekk_i2, \
                                   &ekk_i3,x4, &ekk_i4,&ekk_i5))

#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKNFES(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekknget(x1,x2,x3,i1)      (ekk_i1=i1, EKKNGET(x1,x2,x3,&ekk_i1))

#define  ekknlbs(x1,x2)            (EKKNLBS(x1,x2))

#define  ekknmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10,x11)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   EKKNMDL(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9, \
                                   x10,x11))

#define  ekknslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKNSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekknwmt(x1,x2,i1)         (ekk_i1=i1, EKKNWMT(x1,x2,&ekk_i1))

#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)         \
                                   (ekk_i1=i1,    \
                                    EKKPMDL(x1,x2,x3,x4,x5,x6,x7,&ekk_i1))

#define  ekkpops(x1,x2)            (EKKPOPS(x1,x2))

#define  ekkprsl(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKPRSL(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkprts(x1,x2)            (EKKPRTS(x1,x2))

#define  ekkpshs(x1,x2)            (EKKPSHS(x1,x2))

#define  ekkpssl(x1,x2,i1)         (ekk_i1=i1, EKKPSSL(x1,x2,&ekk_i1))

#define  ekkptmd(x1,x2,i1)         (ekk_i1=i1, EKKPTMD(x1,x2,&ekk_i1))

#define  ekkptmi(x1,x2,i1)         (ekk_i1=i1, EKKPTMI(x1,x2,&ekk_i1))

#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKQMDL(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkqmps(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKQMPS(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                   (ekk_z1=z1,ekk_z2=z2,  \
                                    EKKQPAR(x1,x2,x3,x4,&ekk_z1,&ekk_z2))

#define  ekkqslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKQSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqrmd(x1,x2,x3)         (EKKQRMD(x1,x2,x3))

#define  ekkrgcb(i1,x1)            (ekk_s1=i1, EKKRGCB(&ekk_s1,x1))

#define  ekkrget(x1,x2,x3,i1)      (ekk_i1=i1, EKKRGET(x1,x2,x3,&ekk_i1))

#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKROW(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                    EKKRPTB(x1,x2,&ekk_i1,&ekk_i2, \
                                    &ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkrset(x1,x2,x3,i1)      (ekk_i1=i1, EKKRSET(x1,x2,x3,&ekk_i1))

#define  ekksbnd(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKSBND(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkscal(x1,x2)            (EKKSCAL(x1,x2))


#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   EKKSEL(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))


#define  ekksmap(x1,x2)            (EKKSMAP(x1,x2))

#define  ekksobj(x1,x2)            (EKKSOBJ(x1,x2))

#define  ekksos(x1,x2)             (EKKSOS(x1,x2))

#define  ekkspar(x1,x2)            (EKKSPAR(x1,x2))

#define  ekksslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    EKKSSLV(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkstat(x1,x2)            (EKKSTAT(x1,x2))

/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

#ifdef __cplusplus
}
#endif
#endif
#if defined(EKKC_RS6000)||defined(AS_400)||defined(LINUX)||defined(EKKC_OE)

#ifdef __cplusplus
extern "C"{
#endif
#include <string.h>

/*  Temporary variables used in FORTRAN linkage  */

static long    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static long    ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;

/* OSL routines */
#ifndef OSLLIBAPI
#ifdef OSLMSDLL
#define OSLLIBAPI      __declspec(dllimport)
#define OSLLINKAGE     __stdcall
#define OSLLINKAGE_CB
#else
#ifdef EKKC_OE
#define OSLLIBAPI
#define OSLLINKAGE
#ifdef __cplusplus
#define OSLLINKAGE_CB __cdecl
#else
#define OSLLINKAGE_CB 
#endif
#else
#define OSLLIBAPI
#define OSLLINKAGE
#define OSLLINKAGE_CB
#endif
#endif
#endif

OSLLIBAPI void OSLLINKAGE  ekkbasi(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkbaso(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkbcdo(long *,double *,long *,long *,long *);


OSLLIBAPI void OSLLINKAGE  ekkbmpr(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkbmps(long *,double *,long *);

OSLLIBAPI void OSLLINKAGE  ekkbslv(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkcget(long *,double *,char *,long *);
OSLLIBAPI void OSLLINKAGE  ekkclcb(int *);
OSLLIBAPI void OSLLINKAGE  ekkcol(long *,double *,long *,long *,long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkcopy(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkcrsh(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkcset(long *,double *,char *,long *);
OSLLIBAPI void OSLLINKAGE  ekkdsca(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkdscb(long *,double *,long *,long *,long *,long *,double *,long *,
               long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkdscm(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkemdl(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkgemv(long *,double *,long *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  ekkges(long *,double *,long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkgtmd(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkgtmi(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkhis(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkiget(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkimdl(long *,double *,long *,long *,long *,long *,long *,long *,
               long *,long *,double *,double *);
OSLLIBAPI void OSLLINKAGE  ekkinit(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkinvt(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkiset(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekklmdl(long *,double *,long *,long *,long *,long *,double *,double *,
               double *,double *,double *,long *,long *,double *);
OSLLIBAPI void OSLLINKAGE  ekklpdc(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkmpre(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkmps(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkmsav(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkmset(long *,double *,long *,long *,long *,long *,
               long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkmslv(long *,double *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkmstr(long *,double *,long *,long *);


OSLLIBAPI void OSLLINKAGE  ekkname(long *,double *,long *,char *,long*,long *,
               char *,long *,long *);

OSLLIBAPI void OSLLINKAGE  ekknfes(long *,double *,long *,long *,long *,long *);

OSLLIBAPI void OSLLINKAGE  ekknget(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekknlbs(long *,double *);


OSLLIBAPI void OSLLINKAGE  ekknslv(long *,double *,long *,long *);


OSLLIBAPI void OSLLINKAGE  ekknwmt(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkpmdl(long *,double *,double *,double *,double *,
  double *,double *, long *);
OSLLIBAPI void OSLLINKAGE  ekkpops(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkprsl(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkprts(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkpshs(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkpssl(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkptmd(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkptmi(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkqmdl(long *,double *,long *,long *,long *,long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkqmps(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkqpar(long *,double *,double *,double *,double *,double *);
OSLLIBAPI void OSLLINKAGE  ekkqslv(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkqrmd(long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkrgcb(int *, void *);
OSLLIBAPI void OSLLINKAGE  ekkrget(long *,double *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkrow(long *,double *,long *,long *,long *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekkrptb(long *,double *,long *,long *,long *,long *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkrset(long *,double *,double *,long *);
OSLLIBAPI void OSLLINKAGE  ekksbnd(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkscal(long *,double *);

OSLLIBAPI void OSLLINKAGE  ekksel(long *,double *,char *,long *,char *,char *,
              long *,long *);

OSLLIBAPI void OSLLINKAGE  ekksmap(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekksobj(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekksos(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekkspar(long *,double *);
OSLLIBAPI void OSLLINKAGE  ekksslv(long *,double *,long *,long *);
OSLLIBAPI void OSLLINKAGE  ekkstat(long *,double *);

OSLLIBAPI void OSLLINKAGE  ekkfcls(long *, char *, long *);
OSLLIBAPI void OSLLINKAGE  ekkfopn(long *, char *, char *, 
                      char *, char *, char *, long *, long *);
OSLLIBAPI void OSLLINKAGE  ekkfrew(long *);
OSLLIBAPI void * OSLLINKAGE  ekkdspace95(long);

/* Redefinition for C/C++ drivers  */

#define  ekkbasi(x1,x2,i1)         (ekk_i1=i1, ekkbasi(x1,x2,&ekk_i1))

#define  ekkbaso(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkbaso(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbcdo(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkbcdo(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkbmpr(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkbmpr(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)         (ekk_i1=i1, ekkbmps(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkbslv(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkclcb(i1)               (ekk_s1=i1, ekkclcb(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    ekkcget(x1,x2,x3,&ekk_i1))

#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkcol(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkcopy(x1,x2,i1)         (ekk_i1=i1, ekkcopy(x1,x2,&ekk_i1))

#define  ekkcrsh(x1,x2,i1)         (ekk_i1=i1, ekkcrsh(x1,x2,&ekk_i1))

#define  ekkcset(x1,x2,x3,i1)      (ekk_i1=i1,  \
                                    ekkcset(x1,x2,x3,&ekk_i1))

#define  ekkdsca(x1,x2,i1,i2)      (ekk_longlong=i1,ekk_i2=i2,  \
                                    ekkdsca(x1,x2,&ekk_longlong,&ekk_i2))

#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                    ekkdscb(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5, \
                                    &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkdscm(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkdscm(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkemdl(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))


#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekkfcls(&ekk_i1,x1,x2))

#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, ekk_i7=i2, \
                                   ekkfopn(&ekk_i1,x1,x2,x3,x4,x5,&ekk_i7,x6))

#define  ekkfrew(i1)               (ekk_i1=i1, \
                                   ekkfrew(&ekk_i1))

#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                   (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                    ekkgemv(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                    &ekk_z2,x4))

#define  ekkges(x1,x2,i1,x3)       (ekk_i1=i1, ekkges(x1,x2,&ekk_i1,x3))

#define  ekkgtmd(x1,x2,i1)         (ekk_i1=i1, ekkgtmd(x1,x2,&ekk_i1))

#define  ekkgtmi(x1,x2,i1)         (ekk_i1=i1, ekkgtmi(x1,x2,&ekk_i1))

#define  ekkhis(x1,x2,i1,x3)       (ekk_i1=i1, ekkhis(x1,x2,&ekk_i1,x3))

#define  ekkiget(x1,x2,x3,i1)      (ekk_i1=i1, ekkiget(x1,x2,x3,&ekk_i1))

#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    ekkimdl(x1,x2,&ekk_i1,x3,&ekk_i2,x4, \
                                    x5,&ekk_i3,x6,x7,x8,x9))

#define  ekkinit(x1,x2)            (ekkinit(x1,x2))

#define  ekkinvt(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkinvt(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkiset(x1,x2,x3,i1)      (ekk_i1=i1, ekkiset(x1,x2,x3,&ekk_i1))

#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    ekklmdl(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))

#define  ekklpdc(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekklpdc(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmpre(x1,x2,i1)         (ekk_i1=i1,  \
                                    ekkmpre(x1,x2,&ekk_i1))

#define  ekkmps(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkmps(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmsav(x1,x2,i1,x3)      (ekk_i1=i1, ekkmsav(x1,x2,&ekk_i1,x3))

#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,ekk_i4=i4, \
                                    ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                    ekkmset(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))

#define  ekkmslv(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkmslv(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkmstr(x1,x2,i1,x3)      (ekk_i1=i1, ekkmstr(x1,x2,&ekk_i1,x3))



#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   ekkname(x1,x2,&ekk_i1,x3, &ekk_i2, \
                                   &ekk_i3,x4, &ekk_i4,&ekk_i5))

#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknfes(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekknget(x1,x2,x3,i1)      (ekk_i1=i1, ekknget(x1,x2,x3,&ekk_i1))

#define  ekknlbs(x1,x2)            (ekknlbs(x1,x2))


#define  ekknslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknslv(x1,x2,&ekk_i1,&ekk_i2))




#define  ekknwmt(x1,x2,i1)         (ekk_i1=i1, ekknwmt(x1,x2,&ekk_i1))

#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)         \
                                   (ekk_i1=i1,    \
                                    ekkpmdl(x1,x2,x3,x4,x5,x6,x7,&ekk_i1))

#define  ekkpops(x1,x2)            (ekkpops(x1,x2))

#define  ekkprsl(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkprsl(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkprts(x1,x2)            (ekkprts(x1,x2))

#define  ekkpshs(x1,x2)            (ekkpshs(x1,x2))

#define  ekkpssl(x1,x2,i1)         (ekk_i1=i1, ekkpssl(x1,x2,&ekk_i1))

#define  ekkptmd(x1,x2,i1)         (ekk_i1=i1, ekkptmd(x1,x2,&ekk_i1))

#define  ekkptmi(x1,x2,i1)         (ekk_i1=i1, ekkptmi(x1,x2,&ekk_i1))

#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkqmdl(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkqmps(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkqmps(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                   (ekk_z1=z1,ekk_z2=z2,  \
                                    ekkqpar(x1,x2,x3,x4,&ekk_z1,&ekk_z2))

#define  ekkqslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkqslv(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkqrmd(x1,x2,x3)         (ekkqrmd(x1,x2,x3))

#define  ekkrgcb(i1,x1)            (ekk_i1=i1, ekkrgcb(&ekk_i1,x1))

#define  ekkrget(x1,x2,x3,i1)      (ekk_i1=i1, ekkrget(x1,x2,x3,&ekk_i1))

#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekkrow(x1,x2,&ekk_i1,&ekk_i2,x3,x4,x5))

#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                    ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                    ekkrptb(x1,x2,&ekk_i1,&ekk_i2, \
                                    &ekk_i3, \
                                    &ekk_i4,&ekk_i5,&ekk_i6))

#define  ekkrset(x1,x2,x3,i1)      (ekk_i1=i1, ekkrset(x1,x2,x3,&ekk_i1))

#define  ekksbnd(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekksbnd(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkscal(x1,x2)            (ekkscal(x1,x2))


#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   ekksel(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))


#define  ekksmap(x1,x2)            (ekksmap(x1,x2))

#define  ekksobj(x1,x2)            (ekksobj(x1,x2))

#define  ekksos(x1,x2)             (ekksos(x1,x2))

#define  ekkspar(x1,x2)             (ekkspar(x1,x2))

#define  ekksslv(x1,x2,i1,i2)      (ekk_i1=i1,ekk_i2=i2,  \
                                    ekksslv(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkstat(x1,x2)            (ekkstat(x1,x2))

/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

#ifdef __cplusplus
}
#endif
#endif
#ifdef EKKC_SUN
/* IBM Optimization Subroutine Library (OSL) (5765-128)      */
/* ekkc.h - OSL C header file for Sun-4/SPARCstation Systems */
/* Restricted Materials of IBM                               */
/* Copyright: International Business Machines Corp, 1997     */
#endif
#ifdef EKKC_HP
/* IBM Optimization Subroutine Library (OSL) (5765-135)      */
/* ekkc.h - OSL C header file for HP-PA RISC Systems         */
/* Restricted Materials of IBM                               */
/* Copyright: International Business Machines Corp, 1997     */
#endif
#if defined(EKKC_SUN) || defined(EKKC_HP)

#ifdef __cplusplus
extern "C"{
#endif 
#include <string.h>
 
/* Temporary variables used in redefinitions */
static long    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static long    ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;
 
/* Redefinition of OSL user-callables */
#define  ekkbasi(x1,x2,i1)        (ekk_i1=i1, ekkbasi_(x1,x2,&ekk_i1))

#define  ekkbaso(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbaso_(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbcdo(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkbcdo_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))

#define  ekkbmpr(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbmpr_(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)        (ekk_i1=i1, ekkbmps_(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkclcb(i1)               (ekk_s1=i1, ekkclcb(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcget_(x1,x2,x3,&ekk_i1))
 
#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkcol_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5))
 
#define  ekkcopy(x1,x2,i1)        (ekk_i1=i1, ekkcopy_(x1,x2,&ekk_i1))
 
#define  ekkcrsh(x1,x2,i1)        (ekk_i1=i1, ekkcrsh_(x1,x2,&ekk_i1))
 
#define  ekkcset(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcset_(x1,x2,x3,&ekk_i1))
 
#define  ekkdsca(x1,x2,i1,i2)     (ekk_longlong=i1,ekk_i2=i2,  \
                                   ekkdsca_(x1,x2,&ekk_longlong,&ekk_i2))
 
#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                   ekkdscb_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkdscm(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkdscm_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkemdl_(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekkfcls_(&ekk_i1,x1,x2))

#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknfes_(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, ekk_i7=i2, \
                                   ekkfopn_(&ekk_i1,x1,x2,x3,x4,x5,&ekk_i7,x6))


#define  ekkfrew(i1)              (ekk_i1=i1, \
                                  ekkfrew_(&ekk_i1))
 
#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                  (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                   ekkgemv_(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                   &ekk_z2,x4))
 
#define  ekkges(x1,x2,i1,x3)      (ekk_i1=i1, ekkges_(x1,x2,&ekk_i1,x3))
 
#define  ekkgtmd(x1,x2,i1)        (ekk_i1=i1, ekkgtmd_(x1,x2,&ekk_i1))
 
#define  ekkgtmi(x1,x2,i1)        (ekk_i1=i1, ekkgtmi_(x1,x2,&ekk_i1))
 
#define  ekkhis(x1,x2,i1,x3)      (ekk_i1=i1, ekkhis_(x1,x2,&ekk_i1,x3))
 
#define  ekkiget(x1,x2,x3,i1)     (ekk_i1=i1, ekkiget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekkimdl_(x1,x2,&ekk_i1,x3, \
                                   &ekk_i2,x4, \
                                   x5,&ekk_i3,x6,x7,x8,x9))
 
#define  ekkinit(x1,x2)           (ekkinit_(x1,x2))
 
#define  ekkinvt(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkinvt_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkiset(x1,x2,x3,i1)     (ekk_i1=i1, ekkiset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekklmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))
 
#define  ekklpdc(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekklpdc_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmpre(x1,x2,i1)        (ekk_i1=i1, ekkmpre_(x1,x2,&ekk_i1))
 
#define  ekkmps(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmps_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmsav(x1,x2,i1,x3)     (ekk_i1=i1, ekkmsav_(x1,x2,&ekk_i1, \
                                   x3))
 
#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                   ekkmset_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))
 
#define  ekkmslv(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmslv_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmstr(x1,x2,i1,x3)     (ekk_i1=i1, ekkmstr_(x1,x2, \
                                   &ekk_i1,x3))
 
#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   ekkname_(x1,x2,&ekk_i1,x3,&ekk_i2, \
                                   &ekk_i3,x4,&ekk_i4,&ekk_i5))
 
#define  ekknget(x1,x2,x3,i1)     (ekk_i1=i1, ekknget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekknlbs(x1,x2)           (ekknlbs_(x1,x2))
 
#define  ekknmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10,x11)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekknmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9, \
                                   x10,x11))
 
#define  ekknslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2, \
                                   ekknslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekknwmt(x1,x2,i1)        (ekk_i1=i1, ekknwmt_(x1,x2,&ekk_i1))
 
#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)  \
                                  (ekk_i1=i1,  \
                                   ekkpmdl_(x1,x2,x3,x4,x5,x6,x7, \
                                   &ekk_i1))
 
#define  ekkpops(x1,x2)           (ekkpops_(x1,x2))
 
#define  ekkprsl(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkprsl_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkprts(x1,x2)           (ekkprts_(x1,x2))
 
#define  ekkpshs(x1,x2)           (ekkpshs_(x1,x2))
 
#define  ekkpssl(x1,x2,i1)        (ekk_i1=i1, ekkpssl_(x1,x2,&ekk_i1))
 
#define  ekkptmd(x1,x2,i1)        (ekk_i1=i1, ekkptmd_(x1,x2,&ekk_i1))
 
#define  ekkptmi(x1,x2,i1)        (ekk_i1=i1, ekkptmi_(x1,x2,&ekk_i1))
 
#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkqmps(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmps_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                  (ekk_z1=z1,ekk_z2=z2,  \
                                   ekkqpar_(x1,x2,x3,x4,&ekk_z1, \
                                   &ekk_z2))
 
#define  ekkqslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqrmd(x1,x2,x3)         (ekkqrmd_(x1,x2,x3))

#define  ekkrgcb(i1,x1)            (ekk_i1=i1, ekkrgcb(&ekk_i1,x1))

#define  ekkrget(x1,x2,x3,i1)     (ekk_i1=i1, ekkrget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkrow_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                   ekkrptb_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkrset(x1,x2,x3,i1)     (ekk_i1=i1, ekkrset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekksbnd(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksbnd_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkscal(x1,x2)           (ekkscal_(x1,x2))
 
#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   ekksel_(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))
 
#define  ekksmap(x1,x2)           (ekksmap_(x1,x2))
 
#define  ekksmdl(x1,x2,i1,i2,i3,i4)   \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekksmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4))
 
#define  ekksobj(x1,x2)           (ekksobj_(x1,x2))
 
#define  ekksos(x1,x2)            (ekksos_(x1,x2))

#define  ekkspar(x1,x2)           (ekkspar_(x1,x2))
 
#define  ekksslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkstat(x1,x2)           (ekkstat_(x1,x2))
 
/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

/* OSL user-callable prototypes */
void  ekkbasi_(long *,double *,long *);
void  ekkbaso_(long *,double *,long *,long *);
void  ekkbcdo_(long *,double *,long *,long *,long *);
void  ekkbmpr_(long *,double *,long *,long *);
void  ekkbmps_(long *,double *,long *);
void  ekkbslv_(long *,double *,long *,long *);
/* void  ekkclcb(int *);  */
void  ekkcget_(long *,double *,char *,long *);
void  ekkcol_ (long *,double *,long *,long *,long *,double *, long *);
void  ekkcopy_(long *,double *,long *);
void  ekkcrsh_(long *,double *,long *);
void  ekkcset_(long *,double *,char *,long *);
void  ekkdsca_(long *,double *,long *,long *);
void  ekkdscb_(long *,double *,long *,long *,long *,long *, double *,long *,long *,long *,long *);
void  ekkdscm_(long *,double *,long *,long *);
void  ekkemdl_(long *,double *,long *,long *,long *);
void  ekkfcls_(long *,char *,long *);
void  ekkfopn_(long *,char *,char *,char *,char *,char *,long *,long *);
void  ekkfrew_(long *);
void  ekkgemv_(long *,double *,long *,double *,double *,double *, double *);
void  ekkges_ (long *,double *,long *,double *);
void  ekkgtmd_(long *,double *,long *);
void  ekkgtmi_(long *,double *,long *);
void  ekkhis_ (long *,double *,long *,long *);
void  ekkiget_(long *,double *,long *,long *);
void  ekkimdl_(long *,double *,long *,long *,long *,long *,long *, long *,long *,long *,double *,double *);
void  ekkinit_(long *,double *);
void  ekkinvt_(long *,double *,long *,long *);
void  ekkiset_(long *,double *,long *,long *);
void  ekklmdl_(long *,double *,long *,long *,long *,long *, double *,double *,double *,double *,double *, long *,long *,double *);
void  ekklpdc_(long *,double *,long *,long *,long *);
void  ekkmpre_(long *,double *,long *);
void  ekkmps_ (long *,double *,long *,long *,long *);
void  ekkmsav_(long *,double *,long *,long *);
void  ekkmset_(long *,double *,long *,long *,long *,long *, long *,long *,long *);
void  ekkmslv_(long *,double *,long *,long *,long *);
void  ekkmstr_(long *,double *,long *,long *);
void  ekkname_(long *,double *,long *,char *,long *,long *, char *,long *,long *);
void  ekknfes_(long *,double *,long *,long *,long *,long *);
void  ekknget_(long *,double *,long *,long *);
void  ekknlbs_(long *,double *);
void  ekknmdl_(long *,double *,long *,long *,long *,long *, long *,long *, double *,double *,double *,double *, double *,double *,double *);
void  ekknslv_(long *,double *,long *,long *);
void  ekknwmt_(long *,double *,long *);
void  ekkpmdl_(long *,double *,double *,double *,double *, double *,double *,long *);
void  ekkpops_(long *,double *);
void  ekkprsl_(long *,double *,long *,long *);
void  ekkprts_(long *,double *);
void  ekkpshs_(long *,double *);
void  ekkpssl_(long *,double *,long *);
void  ekkptmd_(long *,double *,long *);
void  ekkptmi_(long *,double *,long *);
void  ekkqmdl_(long *,double *,long *,long *,long *,long *, double *);
void  ekkqmps_(long *,double *,long *,long *);
void  ekkqpar_(long *,double *,double *,double *,double *, double *);
void  ekkqslv_(long *,double *,long *,long *);
void  ekkqrmd_(long *,double *,long *);
/* void  ekkrgcb(int *,void *);*/
void  ekkrget_(long *,double *,double *,long *);
void  ekkrow_ (long *,double *,long *,long *,long *,double *, long *);
void  ekkrptb_(long *,double *,long *,long *,long *,long *,long *, long *);
void  ekkrset_(long *,double *,double *,long *);
void  ekksbnd_(long *,double *,long *,long *);
void  ekkscal_(long *,double *);
void  ekksel_ (long *,double *,char *,long *,char *, char *,long *,long *);
void  ekksmap_(long *,double *);
void  ekksmdl_(long *,double *,long *,long *,long *,long *);
void  ekksobj_(long *,double *);
void  ekksos_(long *,double *);
void  ekkspar_(long *,double *);
void  ekksslv_(long *,double *,long *,long *);
void  ekkstat_(long *,double *);

#ifdef __cplusplus
}
#endif
#endif 
#ifdef EKKC_SGI
/* IBM Optimization Subroutine Library (OSL) (5765-136)       */
/* ekkc.h - OSL C header file for Silicon Graphics Systems    */
/* Restricted Materials of IBM                                */
/* Copyright: International Business Machines Corp, 1997      */

#ifdef __cplusplus
extern "C"{
#endif 
#include <string.h>
 
/* Temporary variables used in redefinitions */
static long    ekk_i1,ekk_i2,ekk_i3,ekk_i4,ekk_i5,ekk_i6,ekk_i7;
static long    ekk_longlong;
static double  ekk_z1, ekk_z2;
static char    ekk_c1, ekk_c2;
static int     ekk_s1;
 
/* Redefinition of OSL user-callables */
#define  ekkbasi(x1,x2,i1)        (ekk_i1=i1, ekkbasi_(x1,x2,&ekk_i1))
 
#define  ekkbaso(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbaso_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkbcdo(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkbcdo_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkbmpr(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbmpr_(x1,x2,&ekk_i1,&ekk_i2))

#define  ekkbmps(x1,x2,i1)        (ekk_i1=i1, ekkbmps_(x1,x2,&ekk_i1))

#define  ekkbslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkbslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkclcb(i1)               (ekk_s1=i1, ekkclcb(&ekk_s1))

#define  ekkcget(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcget_(x1,x2,x3,&ekk_i1))
 
#define  ekkcol(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkcol_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5))
 
#define  ekkcopy(x1,x2,i1)        (ekk_i1=i1, ekkcopy_(x1,x2,&ekk_i1))
 
#define  ekkcrsh(x1,x2,i1)        (ekk_i1=i1, ekkcrsh_(x1,x2,&ekk_i1))
 
#define  ekkcset(x1,x2,x3,i1)     (ekk_i1=i1,  \
                                   ekkcset_(x1,x2,x3,&ekk_i1))
 
#define  ekkdsca(x1,x2,i1,i2)     (ekk_longlong=i1,ekk_i2=i2,  \
                                   ekkdsca_(x1,x2,&ekk_longlong,&ekk_i2))
 
#define  ekkdscb(x1,x2,i1,i2,x3,x4,x5,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6,  \
                                   ekkdscb_(x1,x2,&ekk_i1,&ekk_i2,x3, \
                                   x4,x5, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkdscm(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkdscm_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkemdl(x1,x2,i1,i2,i3)    (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                    ekkemdl_(x1,x2,&ekk_i1,&ekk_i2,&ekk_i3))

#define  ekkfcls(i1,x1,x2)        (ekk_i1=i1, \
                                   ekkfcls_(&ekk_i1,x1,x2))

#define  ekkfopn(i1,x1,x2,x3,x4,x5,i2,x6) (ekk_i1=i1, ekk_i7=i2, \
                                   ekkfopn_(&ekk_i1,x1,x2,x3,x4,x5,&ekk_i7,x6))


#define  ekkfrew(i1)              (ekk_i1=i1, \
                                  ekkfrew_(&ekk_i1))

#define  ekkgemv(x1,x2,i1,z1,x3,z2,x4)   \
                                  (ekk_i1=i1,ekk_z1=z1,ekk_z2=z2,  \
                                   ekkgemv_(x1,x2,&ekk_i1,&ekk_z1,x3, \
                                   &ekk_z2,x4))
 
#define  ekkges(x1,x2,i1,x3)      (ekk_i1=i1, ekkges_(x1,x2,&ekk_i1,x3))
 
#define  ekkgtmd(x1,x2,i1)        (ekk_i1=i1, ekkgtmd_(x1,x2,&ekk_i1))
 
#define  ekkgtmi(x1,x2,i1)        (ekk_i1=i1, ekkgtmi_(x1,x2,&ekk_i1))
 
#define  ekkhis(x1,x2,i1,x3)      (ekk_i1=i1, ekkhis_(x1,x2,&ekk_i1,x3))
 
#define  ekkiget(x1,x2,x3,i1)     (ekk_i1=i1, ekkiget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkimdl(x1,x2,i1,x3,i2,x4,x5,i3,x6,x7,x8,x9)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekkimdl_(x1,x2,&ekk_i1,x3, \
                                   &ekk_i2,x4, \
                                   x5,&ekk_i3,x6,x7,x8,x9))
 
#define  ekkinit(x1,x2)           (ekkinit_(x1,x2))
 
#define  ekkinvt(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkinvt_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkiset(x1,x2,x3,i1)     (ekk_i1=i1, ekkiset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekklmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekklmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9,x10))
 
#define  ekklpdc(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekklpdc_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmpre(x1,x2,i1)        (ekk_i1=i1, ekkmpre_(x1,x2,&ekk_i1))
 
#define  ekkmps(x1,x2,i1,i2,i3)   (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmps_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmsav(x1,x2,i1,x3)     (ekk_i1=i1, ekkmsav_(x1,x2,&ekk_i1, \
                                   x3))
 
#define  ekkmset(x1,x2,i1,i2,i3,i4,i5,i6,i7)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekk_i5=i5,ekk_i6=i6,ekk_i7=i7, \
                                   ekkmset_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,&ekk_i5,&ekk_i6,&ekk_i7))
 
#define  ekkmslv(x1,x2,i1,i2,i3)  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,  \
                                   ekkmslv_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3))
 
#define  ekkmstr(x1,x2,i1,x3)     (ekk_i1=i1, ekkmstr_(x1,x2, \
                                   &ekk_i1,x3))
 
#define  ekkname(x1,x2,i1,x3,i2,i3,x4,i4,i5)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3,    \
                                   ekk_i4=i4,ekk_i5=i5,      \
                                   ekkname_(x1,x2,&ekk_i1,x3,&ekk_i2, \
                                   &ekk_i3,x4,&ekk_i4,&ekk_i5))
 
#define  ekknfes(x1,x2,i1,i2,x3,x4)  \
                                   (ekk_i1=i1,ekk_i2=i2,  \
                                    ekknfes_(x1,x2,&ekk_i1,&ekk_i2,x3,x4))

#define  ekknget(x1,x2,x3,i1)     (ekk_i1=i1, ekknget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekknlbs(x1,x2)           (ekknlbs_(x1,x2))
 
#define  ekknmdl(x1,x2,i1,i2,i3,i4,x3,x4,x5,x6,x7,x8,x9,x10,x11)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekknmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3, \
                                   &ekk_i4,x3,x4,x5,x6,x7,x8,x9, \
                                   x10,x11))
 
#define  ekknslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2, \
                                   ekknslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekknwmt(x1,x2,i1)        (ekk_i1=i1, ekknwmt_(x1,x2,&ekk_i1))
 
#define  ekkpmdl(x1,x2,x3,x4,x5,x6,x7,i1)  \
                                  (ekk_i1=i1,  \
                                   ekkpmdl_(x1,x2,x3,x4,x5,x6,x7, \
                                   &ekk_i1))
 
#define  ekkpops(x1,x2)           (ekkpops_(x1,x2))
 
#define  ekkprsl(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkprsl_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkprts(x1,x2)           (ekkprts_(x1,x2))
 
#define  ekkpshs(x1,x2)           (ekkpshs_(x1,x2))
 
#define  ekkpssl(x1,x2,i1)        (ekk_i1=i1, ekkpssl_(x1,x2,&ekk_i1))
 
#define  ekkptmd(x1,x2,i1)        (ekk_i1=i1, ekkptmd_(x1,x2,&ekk_i1))
 
#define  ekkptmi(x1,x2,i1)        (ekk_i1=i1, ekkptmi_(x1,x2,&ekk_i1))
 
#define  ekkqmdl(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkqmps(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqmps_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqpar(x1,x2,x3,x4,z1,z2)   \
                                  (ekk_z1=z1,ekk_z2=z2,  \
                                   ekkqpar_(x1,x2,x3,x4,&ekk_z1, \
                                   &ekk_z2))
 
#define  ekkqslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkqslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkqrmd(x1,x2,x3)         (ekkqrmd_(x1,x2,x3))
 
#define  ekkrgcb(i1,x1)            (ekk_i1=i1, ekkrgcb(&ekk_i1,x1))

#define  ekkrget(x1,x2,x3,i1)     (ekk_i1=i1, ekkrget_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekkrow(x1,x2,i1,i2,x3,x4,x5)  \
                                  (ekk_i1=i1,ekk_i2=i2,  \
                                   ekkrow_(x1,x2,&ekk_i1,&ekk_i2, \
                                   x3,x4,x5))
 
#define  ekkrptb(x1,x2,i1,i2,i3,i4,i5,i6)  \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4,ekk_i5=i5,ekk_i6=i6, \
                                   ekkrptb_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4,&ekk_i5,&ekk_i6))
 
#define  ekkrset(x1,x2,x3,i1)     (ekk_i1=i1, ekkrset_(x1,x2,x3, \
                                   &ekk_i1))
 
#define  ekksbnd(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksbnd_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkscal(x1,x2)           (ekkscal_(x1,x2))
 
#define  ekksel(x1,x2,x3,i1,c1,c2,i2,i3)  \
                                  (ekk_i1=i1,ekk_c1=c1,ekk_c2=c2, \
                                   ekk_i2=i2,ekk_i3=i3, \
                                   ekksel_(x1,x2,x3,&ekk_i1,&ekk_c1, \
                                   &ekk_c2,&ekk_i2,&ekk_i3))
 
#define  ekksmap(x1,x2)           (ekksmap_(x1,x2))
 
#define  ekksmdl(x1,x2,i1,i2,i3,i4)   \
                                  (ekk_i1=i1,ekk_i2=i2,ekk_i3=i3, \
                                   ekk_i4=i4, \
                                   ekksmdl_(x1,x2,&ekk_i1,&ekk_i2, \
                                   &ekk_i3,&ekk_i4))
 
#define  ekksobj(x1,x2)           (ekksobj_(x1,x2))
 
#define  ekksos(x1,x2)            (ekksos_(x1,x2))

#define  ekkspar(x1,x2)           (ekkspar_(x1,x2))
 
#define  ekksslv(x1,x2,i1,i2)     (ekk_i1=i1,ekk_i2=i2,  \
                                   ekksslv_(x1,x2,&ekk_i1,&ekk_i2))
 
#define  ekkstat(x1,x2)           (ekkstat_(x1,x2))
 
 
/* Callback definitions -- 5/15/97 */
#include "oslcb.h"

/* OSL user-callable prototypes */
void  ekkbasi_(long *,double *,long *);
void  ekkbaso_(long *,double *,long *,long *);
void  ekkbcdo_(long *,double *,long *,long *,long *);
void  ekkbmpr_(long *,double *,long *,long *);
void  ekkbmps_(long *,double *,long *);
void  ekkbslv_(long *,double *,long *,long *);
void  ekkcget_(long *,double *,char *,long *);
/*void  ekkclcb(int *);*/
void  ekkcol_ (long *,double *,long *,long *,long *,double *, long *);
void  ekkcopy_(long *,double *,long *);
void  ekkcrsh_(long *,double *,long *);
void  ekkcset_(long *,double *,char *,long *);
void  ekkdsca_(long *,double *,long *,long *);
void  ekkdscb_(long *,double *,long *,long *,long *,long *, double *,long *,long *,long *,long *);
void  ekkdscm_(long *,double *,long *,long *);
void  ekkemdl_(long *,double *,long *,long *,long *);
void  ekkfcls_(long *,char *,long *);
void  ekkfopn_(long *,char *,char *,char *,char *,char *,long *,long *);
void  ekkfrew_(long *);
void  ekkgemv_(long *,double *,long *,double *,double *,double *, double *);
void  ekkges_ (long *,double *,long *,double *);
void  ekkgtmd_(long *,double *,long *);
void  ekkgtmi_(long *,double *,long *);
void  ekkhis_ (long *,double *,long *,long *);
void  ekkiget_(long *,double *,long *,long *);
void  ekkimdl_(long *,double *,long *,long *,long *,long *,long *, long *,long *,long *,double *,double *);
void  ekkinit_(long *,double *);
void  ekkinvt_(long *,double *,long *,long *);
void  ekkiset_(long *,double *,long *,long *);
void  ekklmdl_(long *,double *,long *,long *,long *,long *, double *,double *,double *,double *,double *, long *,long *,double *);
void  ekklpdc_(long *,double *,long *,long *,long *);
void  ekkmpre_(long *,double *,long *);
void  ekkmps_ (long *,double *,long *,long *,long *);
void  ekkmsav_(long *,double *,long *,long *);
void  ekkmset_(long *,double *,long *,long *,long *,long *, long *,long *,long *);
void  ekkmslv_(long *,double *,long *,long *,long *);
void  ekkmstr_(long *,double *,long *,long *);
void  ekkname_(long *,double *,long *,char *,long *,long *, char *,long *,long *);
void  ekknfes_(long *,double *,long *,long *,long *,long *);
void  ekknget_(long *,double *,long *,long *);
void  ekknlbs_(long *,double *);
void  ekknmdl_(long *,double *,long *,long *,long *,long *, long *,long *, double *,double *,double *,double *, double *,double *,double *);
void  ekknslv_(long *,double *,long *,long *);
void  ekknwmt_(long *,double *,long *);
void  ekkpmdl_(long *,double *,double *,double *,double *, double *,double *,long *);
void  ekkpops_(long *,double *);
void  ekkprsl_(long *,double *,long *,long *);
void  ekkprts_(long *,double *);
void  ekkpshs_(long *,double *);
void  ekkpssl_(long *,double *,long *);
void  ekkptmd_(long *,double *,long *);
void  ekkptmi_(long *,double *,long *);
void  ekkqmdl_(long *,double *,long *,long *,long *,long *, double *);
void  ekkqmps_(long *,double *,long *,long *);
void  ekkqpar_(long *,double *,double *,double *,double *, double *);
void  ekkqslv_(long *,double *,long *,long *);
void  ekkqrmd_(long *,double *,long *);
/*void  ekkrgcb(int *,void *);*/
void  ekkrget_(long *,double *,double *,long *);
void  ekkrow_ (long *,double *,long *,long *,long *,double *, long *);
void  ekkrptb_(long *,double *,long *,long *,long *,long *,long *, long *);
void  ekkrset_(long *,double *,double *,long *);
void  ekksbnd_(long *,double *,long *,long *);
void  ekkscal_(long *,double *);
void  ekksel_ (long *,double *,char *,long *,char *, char *,long *,long *);
void  ekksmap_(long *,double *);
void  ekksmdl_(long *,double *,long *,long *,long *,long *);
void  ekksobj_(long *,double *);
void  ekksos_(long *,double *);
void  ekkspar_(long *,double *);
void  ekksslv_(long *,double *,long *,long *);
void  ekkstat_(long *,double *);

#ifdef __cplusplus
}
#endif
#endif
