/*___________________________________________________________________________*/
/* IBM Optimization Solutions and Library Optimization Library               */
/* osln.h - OSL C header file for index control variables                    */
/* (c) IBM Corp, 1990,1997 All rights reserved.                              */
/*                                                                           */
/* US Government Users Restricted Rights - Use, duplication, or disclosure   */
/* restricted by GAS ADP Schedule Contract with IBM Corp.                    */
/*___________________________________________________________________________*/
#define OSLNLN 69           /* number of index control variables */
static  long osln[OSLNLN];  /* array for index control variables */
#define NROWLOWER  osln[0]  /* index into dspace for the first
                               element of row lower bounds */
#define NROWACTS   osln[1]  /* index into dspace for the first
                               element of row activities */
#define NROWUPPER  osln[2]  /* index into dspace for the first
                               element of row upper bounds */
#define NROWSLACKS osln[3]  /* index into dspace for the first
                               element of row slacks */
#define NROWDUALS  osln[3]  /* alternate name for NROWSLACKS */
#define NROWSTAT   osln[4]  /* index into mspace for the first
                               element of the row status vector */
#define NCOLLOWER  osln[5]  /* index into dspace for the first
                               element of column lower bounds */
#define NCOLSOL    osln[6]  /* index into dspace for the 1st element
                               of the solution (column activities) */
#define NCOLUPPER  osln[7]  /* index into dspace for the 1st element
                               of column upper bounds */
#define NCOLRCOSTS osln[8]  /* index into dspace for the 1st element
                               of reduced costs */
#define NCOLSTAT   osln[9]  /* index into mspace for the 1st element
                               of the column status vector */
#define NOBJECTIVE osln[10] /* index into dspace for the 1st element
                               of column costs (obj. func. coeff.) */
#define NROWNAMES  osln[11] /* index into dspace for the 1st element
                               of row names */
#define NCOLNAMES  osln[12] /* index into dspace for the 1st element
                               of column names */
#define NROWSCALES osln[13] /* index into dspace for the 1st element
                               of row scale factors */
#define NCOLSCALES osln[14] /* index into dspace for the 1st element
                               of column scale factors */
#define NPRESOLVE  osln[15] /* index into mspace for the 1st element
                               of the presolve region */
#define NROWCC     osln[16] /* index into mspace for the 1st element
                               of rows for matrix (column copy) */
#define NCOLRC     osln[17] /* index into mspace for the 1st element
                               of columns for matrix (row copy) */
#define NELEMCC    osln[18] /* index into dspace for the 1st element
                               of elements for matrix (column copy) */
#define NELEMRC    osln[19] /* index into dspace for the 1st element
                               of columns for matrix (row copy) */
#define NROWRC     osln[20] /* index into mspace for the 1st element
                               of row starts (row copy) */
#define NCOLCC     osln[21] /* index into mspace for the 1st element
                               of column starts (column copy) */
#define NFIRSTFREE osln[22] /* index into dspace of the 1st element
                               of free space */
#define NLASTFREE  osln[23] /* index into dspace of the last element
                               of free space */
#define NBLOCKCOL  osln[24] /* index into mspace for the 1st element
                               of column entries for latest block */
#define NBLOCKROW  osln[25] /* index into mspace for the 1st element
                               of row entries for latest block */
#define NBLOCKELEM osln[26] /* index into dspace for the 1st element
                               of elements for latest block */
#define NINTINFO   osln[27] /* index into mspace for the 1st element
                               of integer information */
#define NROWAUX    osln[28] /* index into dspace for the 1st element
                               of row auxiliary solve information */
#define NCOLAUX    osln[29] /* index into dspace for the 1st element
                               of row auxiliary solve information */
#define NSOBJUPC   osln[30] /* index into dspace created by ekksobj
                               for the first element of the array of
                               cost upper limits */
#define NSOBJDNC   osln[31] /* index into dspace created by ekksobj
                               for the first element of the array of
                               cost lower limits */
#define NSOBJUPV   osln[32] /* index into dspace created by ekksobj
                               for the first element of ranges of the
                               objective function values corresp. to
                               the upper limits on cost coefficients
                               indexed by Nsobjupc */
#define NSOBJDNV   osln[33] /* index into dspace created by ekksobj
                               for the first element of ranges of the
                               objective function values corresp. to
                               the lower limits on cost coefficients
                               indexed by Nsobjdnc */
#define NSOBJUPE   osln[34] /* index into mspace created by ekksobj
                               for the first element of the array of
                               entering rows or columns corresp. to
                               the increased cost coeffs. indexed by
                               Nsobjupc */
#define NSOBJDNE   osln[35] /* index into mspace created by ekksobj
                               for the 1st element of the array of
                               entering rows or columns corresponding
                               to the decreased cost coefficients
                               indexed by Nsobjdnc */
#define NSOBJUPL   osln[36] /* index into mspace created by ekksobj
                               for the 1st element of the array of
                               leaving rows or columns corresponding
                               to the increased cost coefficients
                               indexed by Nsobjupc */
#define NSOBJDNL   osln[37] /* index into mspace created by ekksobj
                               for the 1st element of the array of
                               leaving rows or columns corresp. to
                               the decreased cost coefficients
                               indexed by Nsobjdnc */
#define NSBNDCUPB  osln[38] /* index into dspace created by ekksbnd
                               for the first element of the upper
                               limits on column bounds */
#define NSBNDCDNB  osln[39] /* index into dspace created by ekksbnd
                               for the first element of the lower
                               limits on column bounds */
#define NSBNDCUPV  osln[40] /* index into dspace created by ekksbnd
                               for the 1st element of the ranges of
                               the objective function values corresp.
                               to the upper limits on column bounds
                               indexed by Nsbndcupb */
#define NSBNDCDNV  osln[41] /* index into dspace created by ekksbnd
                               for the 1st element of ranges of the
                               objective function values corresp. to
                               the lower limits on column bounds
                               indexed by Nsbndcdnb */
#define NSBNDCUPE  osln[42] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               entering rows or columns corresp. to
                               the upper limits on column bounds
                               indexed by Nsbndcupb */
#define NSBNDCDNE  osln[43] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               entering rows or columns corresp. to
                               the lower limits on column bounds
                               indexed by Nsbndcdnb */
#define NSBNDCUPL  osln[44] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               leaving rows or columns corresp. to
                               the upper limits on column bounds
                               indexed by Nsbndcupb */
#define NSBNDCDNL  osln[45] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               leaving rows or columns corresp. to
                               the lower limits on column bounds
                               indexed by Nsbndcdnb */
#define NSBNDRUPB  osln[46] /* index into dspace created by ekksbnd
                               for the 1st element of the upper
                               limits on row bounds */
#define NSBNDRDNB  osln[47] /* index into dspace created by ekksbnd
                               for the first element of the lower
                               limits on row bounds */
#define NSBNDRUPV  osln[48] /* index into dspace created by ekksbnd
                               for the 1st element of the ranges of
                               the objective function values corresp.
                               to the upper limits on row bounds
                               indexed by Nsbndrupb */
#define NSBNDRDNV  osln[49] /* index into dspace created by ekksbnd
                               for the 1st element of ranges of the
                               objective function values corresp. to
                               the lower limits on row bounds indexed
                               by Nsbndrdnb */
#define NSBNDRUPE  osln[50] /* index into mspace created by ekksbnd
                               for the first element of the array of
                               entering rows or columns corresp. to
                               the upper limits on row bounds
                               indexed by Nsbndrupb */
#define NSBNDRDNE  osln[51] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               entering rows or columns corresp. to
                               the lower limits on row bounds indexed
                               by Nsbndrdnb */
#define NSBNDRUPL  osln[52] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               leaving rows or columns corresp. to
                               the upper limits on row bounds indexed
                               by Nsbndrupb */
#define NSBNDRDNL  osln[53] /* index into mspace created by ekksbnd
                               for the 1st element of the array of
                               leaving rows or columns corresp. to
                               the lower limits on row bounds
                               indexed by Nsbndrdnb */
#define NSELLISTCOL osln[54] /* index into mspace for the column
                                selection list */
#define NSELLISTROW osln[55] /* index into mspace for the row
                                selection list */
#define NSPARCOST  osln[56] /* index into dspace for the parametric
                               cost (objective) change vector
                               created for ekkspar */
#define NSPARRLO   osln[57] /* index into dspace for the row lower
                               bounds parametric change vector
                               created for ekkspar */
#define NSPARRUP   osln[58] /* index into dspace for the row upper
                               bounds parametric change vector
                               created for ekkspar */
#define NSPARCLO   osln[59] /* index into dspace for the column lower
                               bounds parametric change vector
                               created for ekkspar */
#define NSPARCUP   osln[60] /* index into dspace for the column upper
                               bounds parametric change vector
                               created for ekkspar */
#define NARCID     osln[61] /* index into mspace for the 1st element
                               of the indices of the arcs in
                               the basis */
#define NLEVEL     osln[62] /* index into mspace for the 1st element
                               of the array of node levels */
#define NPARENT    osln[63] /* index into mspace for the 1st element
                               of the array of parent nodes */
#define NPREORDER  osln[64] /* index into mspace for the 1st element
                               of the preorder traversal array */
#define NREVPREORDER osln[65] /* index into mspace for the 1st
                                 element of the reverse preorder
                                 traversal array */
#define NQROW      osln[66] /* index into mspace for the 1st
                               element of rows for quad matrix
                               (col copy) or index into mspace for
                               the 1st element of row entries for
                               quad matrix (index copy) */
#define NQCOL      osln[67] /* index into mspace for the 1st
                               element of column starts for quad
                               matrix (col copy) or index into
                               mspace for the 1st element of column
                               entries for quad matrix (index copy) */
#define NQELEM     osln[68] /* index into mspace for the 1st element
                               of elements for quad matrix (col or
                               index copy) */
