// -------------------------------------------------------------------
//                             EXNSLV
//  This program reads a network problem from an MPS file and solves
//  it using the primal network simplex method.
// ------------------------------------------------------------------- 

#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include "ekk_c_api.h"

void main()
{
    // Initialize OSL environment 
    EKKContext * env;
    env = ekk_initializeContext();

    // Create an OSL model "test" 
    EKKModel * test;
    test = ekk_newModel(env,NULL);

    // Read model data from MPS file 
    int rtcod = ekk_importModel(test,"exlp4.mps");  

    // Set Iiterufreq to a large number 
    rtcod = ekk_setIiterufreq(test,999999);

    // Solve using the Network simplex method 
    rtcod = ekk_primalNetwork(test,3);

    // Print the solution 
    rtcod = ekk_printSolution(test);

    // Delete the model 
    rtcod = ekk_deleteModel(test);
  
    // OSL Destructor
    ekk_endContext(env);
}
